import "package:flutter/material.dart";
import 'button.dart';
import "pagination_helpers.dart";

class ZirPagination extends StatefulWidget {
  final searchKey;
  ZirPagination({this.searchKey});

  @override
  Pagination createState() => new Pagination();
}

class Pagination extends State<ZirPagination> {
  num page = 0;
  num pageLength = 5;
  var pageHelper = new PaginationHelper();
  num count = 0;
  List pages = [];

  @override
  void initState() {
    super.initState();

    setState(() {
      pages = pageHelper.getPages(
          page + 1,
          widget.searchKey.currentState.length,
          widget.searchKey.currentState.results);
    });
  }

  _runSelected(num pageNum) {
    if (pageNum >= 0) {
      setState(() {
        page = pageNum;
        pages = pageHelper.getPages(
          page + 1,
          widget.searchKey.currentState.length,
          widget.searchKey.currentState.results);
      });
      widget.searchKey.currentState
          .changeOffset((pageNum) * widget.searchKey.currentState.results);
          widget.searchKey.currentState.handleQuery();
    }

  }

  @override
  Widget build(BuildContext context) {
    return Row(children: [
      PaginationButton(
          widget: Icon(Icons.arrow_back, size: 10),
          value: page,
          handler: () => _runSelected(page - 1 >= 0 ? page - 1 : 0),
          length: widget.searchKey.currentState.length,
          next: false
          ),
      PaginationButton(
          widget: Text("1"),
          value: 1,
          active: page == 0 ? true : false,
          handler: () => _runSelected(0),
          length: widget.searchKey.currentState.length,
          next: false
          ),
      Visibility(
          child: Padding(
              padding: EdgeInsets.only(left: 4, right: 4), child: Text("...")),
          visible: page > 3 && widget.searchKey.currentState.fieldValue != ""),
      Container(
          child: Row(
              children: pages.map((e) {
        return PaginationButton(
            widget: Text("$e"),
            active: page + 1 == e ? true : false,
            value: e,
            handler: () => _runSelected(e -1),
            length: widget.searchKey.currentState.length,
            next: false
          );
      }).toList())),
      PaginationButton(
          widget: Icon(
            Icons.arrow_forward,
            size: 10,
          ),
          value: page + 1,
          handler: () => _runSelected(page + 1),
          length: widget.searchKey.currentState.length,
          next: true
          ),
    ]);
  }
}
